unit Plug;
{*
 * Konnekt Delphi SDK (Software Development Kit)
 *
 * Nagwek: Plugin shared
 * Modyfikowany: 2006-08-31
 * Zgodny z wersj: 0.6.22.x
 * Info: Podstawowy nagwek.
 *
 * rodowisko: Borland Delphi 7
 *
 * http://www.konnekt.info/
 *
 * (C) 2002-2006 Stamina
 * SDK suy do przygotowywania oprogramowania wsppracujcego
 * z programem Konnekt. Autorzy nie ponosz adnej odpowiedzialnoci
 * za wykorzystanie tego kodu.
 * Kod zawarty w SDK moe by uywany tylko w projektach dotyczcych
 * programu Konnekt! 
 *}

interface

uses
  SysUtils, Windows;

const
  KONNEKT_SDK_V = 2;

const
  HISTORY_IGNORED_NAME = 'ignorowani';
  HISTORY_IGNORED_DIR = 'deleted';

{   Struktura uywana podczas przesyania wiadomoci.
    Jest uywana jako bazowa dla wikszych struktur...
  }
type
     sCNTSEARCHPtr = ^sCNTSEARCH;
         sCNTSEARCH =packed record
            s_size:word;
            status:integer;
            uid:array [0..255] of char;
            name:array [0..100] of char;
            surname:array [0..100] of char;
            nick:array [0..100] of char;
            city:array [0..50] of char;
            email:array [0..100] of char;
            phone:array [0..50] of char;
            other:array [0..255] of char;
            gender:integer; ///< Pe 0 - nieznana , 1 - kobieta , 2 - mczyzna
            born_min:integer; ///< Urodzony, OD roku
            born_max:integer; ///< Urodzony, DO roku
            net:integer;    ///< Numer sieci.
            start:integer;  ///< Od jakiej pozycji pokazywa dalej.
                        /// Przy zwracaniu, ostatni znaleziony kontakt powinien mie ustawiony \start
                        /// na pozycj od ktrej mona wznowi wyszukiwanie.
            handle:integer; ///< Uchwyt do okna wyszukiwania
         end;
  sIMessage_basePtr = ^sIMessage_base; // wskanik do struktury
  sIMessage_base = packed record
    size: Word;
    id: Cardinal;
    flag: Cardinal;
    net: Integer;
    type_: Integer;
    sender: Cardinal;
  end;
{ Funkcje uatwiajce uzupenianie recordw, pole size zawsze jest ustawiane
  wic nie trzeba si przejmowac ;) }
function sIMessage_baseB(id: Cardinal; net: Integer; _type: Cardinal): sIMessage_base; overload;
function sIMessage_baseB(): sIMessage_base; overload;
function sIMessage_baseB(id: Cardinal): sIMessage_base; overload;
function sIMessage_baseB(base: sIMessage_basePtr): sIMessage_base; overload;


{   Struktura uywana podczas przesyania wiadomoci.
    Moe by struktur bazow dla wikszych struktur ...
    p1 i p2 mog by zastpione dowolnymi typami, najlepiej o
    rozmiarze po 4 bajty ...
}
type
  sIMessage_2paramsPtr = ^sIMessage_2params;  // wskanik do struktury
  sIMessage_2params = packed record
    size: Word;
    id: Cardinal;
    flag: Cardinal;
    net: Integer;
    type_: Cardinal;
    sender: Cardinal;     //!! dotd odziedziczone z sIMessage_base, ale e delphi nie ma czegos takiego dla recordow wiec trzeba pola powtarzac!!
    p1: Integer;
    p2: Integer;
  end;
{ Funkcje uatwiajce uzupenianie recordw, pole size zawsze jest ustawiane
  wic nie trzeba si przejmowac ;) }
function sIMessage_2paramsB(id: Cardinal; net: Integer; _type: Cardinal; p1: Integer; p2: Integer): sIMessage_2params; overload;
function sIMessage_2paramsB(): sIMessage_2params; overload;
function sIMessage_2paramsB(id: Cardinal; p1: Integer; p2: Integer): sIMessage_2params; overload;
function sIMessage_2paramsB(base: sIMessage_base): sIMessage_2params; overload;

const
  NET_FIRST = -2;          ///< Wiadomo dotrze do pierwszej wtyczki (dowolnej sieci), ktra potrafi j obsuy.
  NET_BROADCAST = -1;      ///< Wiadomo dotrze do wtyczek wszystkich sieci.
  NET_BC = NET_BROADCAST;  ///< Odpowiednik #NET_BROADCAST.
  NET_NONE = 0;            ///< Wiadomosci do rdzenia.
  NET_NET = 1;             ///< Wtyczki obsugujce protok "wasny".
  NET_INTERNAL = 2;
  NET_SOUND = 3;           ///< Dwik
  NET_UPDATE = 4;           ///< Update
  NET_OTHER = 6;         ///< Wtyczki nie posiadajce akcji, nie obsugujce wiadomoci itp.
  NET_GG = 10;            ///< Wtyczki obsugujce protok GG
  NET_ICQ = 11;            ///< Wtyczki obsugujce protok ICQ
  NET_JABBER = 12;            ///< Wtyczki obsugujce protok JABBER
  NET_EMAIL = 13;            ///< Wtyczki obsugujce EMaile
  NET_SMS = 14;            ///< Wtyczki obsugujce SMSy
  NET_KLAN = 15;
  NET_KSTYLE = 16;
  NET_EXPIMP = 17;
  NET_KONNFERENCJA = 20;
  NET_AIM = 60;            ///< Wtyczki obsugujce protok AIM
  NET_YAHOO = 61;            ///< Wtyczki obsugujce protok YAHOO
  NET_MSN = 62;            ///< Wtyczki obsugujce protok MSN
  NET_TLEN = 63;            ///< Wtyczki obsugujce protok TLEN
  NET_KTRANSFER = 130; ///< kTransfer

const
  AC_USER = 0;      ///< Akcja jest przypisana do uytkownika.
  AC_NONE = -1;    ///< Akcja nie jest przypisana do adnego kontaktu.
  AC_CURRENT = -2; ///< Ostatnio przypisany kontakt.


type
  sUIActionPtr = ^sUIAction;  // wskanik do struktury
  sUIAction = packed record
    id: Cardinal;
    parent: Cardinal;
    cnt: Integer;
  end;

function sUIActionB(): sUIAction; overload;
function sUIActionB(parent: Cardinal; id: Cardinal; cnt: Integer = AC_CURRENT): sUIAction; overload;

type
  sUIActionNotify_basePtr = ^sUIActionNotify_base;  // wskanik do struktury
  sUIActionNotify_base = packed record
    s_size: Word;
    act: sUIAction;
    code: Cardinal;
    reserved: Integer;
  end;


type
  sUIActionNotify_2paramsPtr = ^sUIActionNotify_2params;
  sUIActionNotify_2params = packed record
    s_size: Word;
    act: sUIAction;
    code: Cardinal;
    reserved: Integer;   //!! dotd odzedziczone z sUIActionNotify_base
    notify1: Cardinal;
    notify2: Cardinal;
  end;


{ Identyfikatory tablic. }

sIMessage_StatusChange=packed record
  sm:sIMessage_base;
  cntID:cardinal;
  status:Cardinal;
  info:pchar;
end;


sIMessage_StatusChange1=packed record
  msgID:integer;
  cntID:integer;
  status:integer;
end;

sIMessage_msgBox=packed record
  sm:sIMessage_base;
  msg:pchar;
  flags:cardinal;
  title:pchar;
  parent:integer;
end;

sIMessage_plugOutPtr = ^sIMessage_plugOut;
sIMessage_plugOut = packed record
  sm:sIMessage_base;
  plugId:Integer;
  reason:pchar;
  restart:integer;
  unload:integer;
end;

const
  erNo = 0;
  erAsk = 1;
  erYes = 2;
  erAskShut = 3;
  erShut = 4;

  euNow=1;
  euNextStart=2;
  euNowAndOnNextStart=3 ;


type
sIMessage_UIMakePopupPtr = ^sIMessage_UIMakePopup;
sIMessage_UIMakePopup = packed record
  size: Word;
  id: Cardinal;
  flag: Cardinal;
  net: Integer;
  type_: Cardinal;
  sender: Cardinal;
  _action: sUIAction;
  _uFlags:Integer;
  _x :Integer;
  _y :Integer;
  _nReserved :Integer;
  _startFrom :Integer;
  _hWndMenu :Cardinal;
  Rect :PRect;
end;

function sIMessage_UIMakePopupB(action :sUiAction; uFlags :Integer; x :Integer; y :Integer; nReserved :Integer; hWnd :Cardinal; prcRect :PRect; startFrom :Integer = 0):sIMessage_UIMakePopup;


type tTable = Shortint;

const
  DTCFG: tTable = 0; ///< Tablica konfiguracji
  DTCNT: tTable = 1; ///< Tablica kontaktw
  DTMSG: tTable = 2; ///< Tablica wiadomoci
  DTNONE: tTable = -1;

const
  UIAIM_STATUS = 1; ///< sUIActionInfo::status i sUIActionInfo::statusMask s ustawione.
  UIAIM_EXSTYLE = 2; ///< sUIActionInfo::exStyle i sUIActionInfo::exStyleMas s ustawione.
  UIAIM_P1 = 4; ///< sUIActionInfo::p1 jest ustawiony.
  UIAIM_P2 = 8; ///< sUIActionInfo::p2 jest ustawiony.
  UIAIM_PARAM = $10; ///< sUIActionInfo::param jest ustawiony.
  UIAIM_ICO = UIAIM_P1;
  UIAIM_TXT = $40;  ///< sUIActionInfo::txt i sUIActionInfo::txtSize s ustawione.
  UIAIM_COL = UIAIM_P1; ///< \blank
  UIAIM_POS = $100;  ///< \blank
  UIAIM_SIZE = $200;  ///< \blank
  UIAIM_HANDLE = $400;  ///< \blank
  UIAIM_TYPE = $800;  ///< \blank
  UIAIM_VALUE_CONVERT = $10000; ///< Ustawiona warto akcji powinna zosta przekonwertowana (np. z formatu wartoci akcji do formatu pola w bazie i na odwrt)
  UIAIM_ALL = $35F; ///< Wszystkie powysze.

type
  sUIActionInfoPtr = ^sUIActionInfo;
  sUIActionInfo = packed record
    s_size: Word;
    act: sUIAction;  ///< Identyfikatory.
    pos: Cardinal;  ///<Pozycja na licie w grupie. Pos == -1 oznacza "na kocu" (podczas \ref IMI_ACTION "wstawiania").
                    /// \todo Powinien potrafi rwnie zmieni pozycj.
    type_: Cardinal; ///<Typ kontrolki przypisanej do akcji ( \ref actt_ ).
    handle: THandle;     ///<Uchwyt do kontrolki akcji (np w windowsach uchwyty do HWND lub HMENU)
    reserved: Pointer;
    mask: Cardinal;       { Maska.
                            Oznacza ktre pola w strukturze s
                            ustawione.
                            \attention Pole \a act musi by \b zawsze ustawione! <br>
                            \sa \ref uiaim_
                           }
    status: Cardinal;     ///<\ref actm_ "Status".
    statusMask: Cardinal; ///<Oznacza ktre pola w \a status powinny by zmienione.
    exStyle: Cardinal;    { Dodatkowe style . \attention W tej chwili nie s one uywane! }
    exStyleMask: Cardinal;///<Oznacza ktre pola w \a exStyle powinny by zmienione.
    txt: PChar;     ///< Tekst przypisany do akcji.
    txtSize: Cardinal; ///< Rozmiar bufora w txt.
    param: Integer;      ///<Parametr uytkownika.
    p1: Integer;         ///<Dodatkowy parametr uzywany przez typy kontrolek.
    p2: Integer;         ///<Dodatkowy parametr uzywany przez typy kontrolek.
    w,h: Smallint; ///< Wysoko / szeroko kontrolki
  end;

function sUIActionInfoB(): sUIActionInfo; overload;
function sUIActionInfoB(parent: Integer; id: Integer; pos: Integer; status: Integer = 0; txt: PChar = nil; p1: Integer = 0; w: Smallint = 0; h: Smallint = 0; p2: Integer = 0; param: Integer = 0): sUIActionInfo; overload;
function sUIActionInfoB(parent: Integer; id: Integer): sUIActionInfo; overload;
function sUIActionInfoB(a: sUIAction): sUIActionInfo; overload;

type
  sUIActionInfo_cfgPtr = ^sUIActionInfo_cfg;
  sUIActionInfo_cfg = packed record
    s_size: Word;
    act: sUIAction;  ///< Identyfikatory.
    pos: Cardinal;  ///<Pozycja na licie w grupie. Pos == -1 oznacza "na kocu" (podczas \ref IMI_ACTION "wstawiania").
                    /// \todo Powinien potrafi rwnie zmieni pozycj.
    type_: Cardinal; ///<Typ kontrolki przypisanej do akcji ( \ref actt_ ).
    handle: THandle;     ///<Uchwyt do kontrolki akcji (np w windowsach uchwyty do HWND lub HMENU)
    reserved: Pointer;
    mask: Cardinal;       { Maska.
                            Oznacza ktre pola w strukturze s
                            ustawione.
                            \attention Pole \a act musi by \b zawsze ustawione! <br>
                            \sa \ref uiaim_
                           }
    status: Cardinal;     ///<\ref actm_ "Status".
    statusMask: Cardinal; ///<Oznacza ktre pola w \a status powinny by zmienione.
    exStyle: Cardinal;    { Dodatkowe style . \attention W tej chwili nie s one uywane! }
    exStyleMask: Cardinal;///<Oznacza ktre pola w \a exStyle powinny by zmienione.
    txt: PChar;     ///< Tekst przypisany do akcji.
    txtSize: Cardinal; ///< Rozmiar bufora w txt.
    param: Integer;      ///<Parametr uytkownika.
    p1: Integer;         ///<Dodatkowy parametr uzywany przez typy kontrolek.
    p2: Integer;         ///<Dodatkowy parametr uzywany przez typy kontrolek.
    w,h: Smallint; ///< Wysoko / szeroko kontrolki
    x,y: Smallint; ///< Przesunicie wzgldem osi x/y
  end;

function sUIActionInfo_cfgB(): sUIActionInfo_cfg; overload;
function sUIActionInfo_cfgB(parent: Integer; id: Integer; pos: Integer = -1; status: Integer = 0; txt: PChar = nil; col: Integer = 0; w: Smallint = 0; h: Smallint = 0; p2: Integer = 0; param: Integer = 0): sUIActionInfo_cfg; overload;
function sUIActionInfo_cfgB(parent: Integer; id: Integer; pos: Integer = -1; status: Integer = 0; txt: PChar = nil; col: Integer = 0; x: Smallint = 0; y: Smallint = 0; w: Smallint = 0; h: Smallint = 0; p2: Integer = 0; param: Integer = 0): sUIActionInfo_cfg; overload;

type HINSTANCE = Longword;

  { Rodzaj zapisywanej informacji dla cCtrl::IMDEBUG() }
type enDebugLevel = (
    DBG_NONE = 0,
    DBG_NET = 1,
    DBG_TRAFFIC = 2 , 
    DBG_DUMP = 4 , 
    DBG_FUNC = 8 , 
    DBG_MISC = $10 ,
    DBG_ERROR = $20 ,
    DBG_WARN = $40 ,
    DBG_LOG = $100 ,
    DBG_DEBUG = $1000 ,
    DBG_ALL = $0FFF
    );

const
  DT_ROWID_MASK = $40000000;  ///< Bit oznaczajcy, e "numer wiersza", jest identyfikatorem wiersza.
                             /// \sa #ISCNTID #GETCNTID cCtrl::DTgetID()

  { Typy kolumn
    Typ kolumny skada si z 8 bitowego typu (jak np. #DT_CT_INT) i flag.
  }
const
  DT_CT_INT = 0;    ///< 4 bajty (int)
  DT_CT_PCHAR = 1;  ///< Tekst zakoczony znakiem '0'.
  DT_CT_STR = DT_CT_PCHAR;
  DT_CT_64 = 3;    ///< 8 bajtw (__int64, double ...)
  DT_CT_UNKNOWN = -1;  ///< dla sDTValue, typ nieznany (zostanie ustawiony).
  DT_CF_NOSAVE = $100;  ///< Kolumna nie zostanie zapisana do pliku.
  DT_CF_SECRET = $400;       ///< Kolumna moe by hasem i powinna by odpowiednio strzeona...
  DT_CF_CXOR = $01000; ///< Kodowanie kolumn poprzez XORing. Dziaa tylko jako DT_CT_PCHAR|DT_CT_CXOR.

type
  sDTValuePtr = ^sDTValue;
  sDTValue = packed record
    type_: Smallint; ///< Typ przekazywanej wartoci
    case Integer of
      0: (vInt: Integer);
      1: (vInt64: Int64);
      2: (vChar: PChar; buffSize: Cardinal)
  end;

function sDTValueB(type_: Smallint = DT_CT_UNKNOWN): sDTValue;

type
  sIMessage_setColumnPtr = ^sIMessage_setColumn;
  sIMessage_setColumn = packed record
    size: Word;
    id: Cardinal;
    flag: Cardinal;
    net: Integer;
    type_: Cardinal;
    sender: Cardinal;   //<-- Dotd odziedziczone z sIMessage_base
    //__msgID: Integer;
    table: tTable;
    _id: Integer;
    _type: Integer;
    def: Integer; ///< Przechowuje inta, PChar lub PInt64 w zalenosci od DT_CT_
    name: PChar;
  end;

function sIMessage_setColumnB(table: tTable; id: Integer; type_: Integer; def: Integer; const name: PChar = nil): sIMessage_setColumn; overload;
function sIMessage_setColumnB(table: tTable; id: Integer; type_: Integer; const def: PChar; const name: PChar = nil): sIMessage_setColumn; overload;
function sIMessage_setColumnB(id: Integer; type_: Integer; def: Integer; const name: PChar = nil): sIMessage_setColumn; overload;
function sIMessage_setColumnB(id: Integer; type_: Integer; const def: PChar; const name: PChar = nil): sIMessage_setColumn; overload;

const
  IMI_BASE = 10000;
  IM_BASE = 20000;
  IM_SHARE = 30000;
  IM_USER = 40000;
  IM_CHANGESTATUS = IM_SHARE+3005;
  IM_CNT_SEARCH = IM_BASE+4010 ;
  IM_CNT_CHANGED = IM_BASE+4006 ;
  IM_CNT_STATUSCHANGE = IM_BASE+4011;
  IM_PLUG_PRIORITY = IM_BASE+21;
  IM_ALLPLUGINSINITIALIZED = IM_BASE + 22;
  IM_SENDREQUEST = 1313500;
  IM_CONNECT = IM_SHARE+3000;
  IM_AWAY = IM_SHARE+3002;
  IM_BACK = IM_SHARE+3003;
  IM_ISCONNECTED = IM_SHARE+3006;
  IM_GET_STATUS = IM_SHARE+31;
  IM_GET_STATUSINFO = IM_SHARE+32;
  IM_GET_UID = IM_SHARE+33;
  IM_MSG_SEND = IM_SHARE+100 ;
  IM_MSG_CHARLIMIT = IM_BASE + 105;
  IM_CNT_DOWNLOAD = IM_SHARE+4001;
  IM_CNT_UPLOAD = IM_SHARE+4000 ;
  IM_CNT_ADD = IM_BASE+4003 ;
  IM_IGN_CHANGED = IM_BASE+4021;

  IMI_ICONRES = IMI_BASE+109;
  IMI_ICONGET = IMI_BASE+136 ;
  IMI_GETICONLIST = IMI_BASE+134;
  IMI_GETICONINDEX = IMI_BASE+133;
  IMI_REFRESH_LST = IMI_BASE+2001;
  IMI_REFRESH_CNT = IMI_BASE+2000 ;
  IMI_CNT_DETAILS_SUMMARIZE = IMI_BASE+1016;
  IMI_CNT_SEARCH_FOUND = IMI_BASE+4000 ;
  IMI_ACTION = IMI_BASE+101;
  IMI_GROUP = IMI_BASE+102;
  IMI_ACTION_CALL = IMI_BASE+103;
  IMI_ACTION_GET = IMI_BASE+107;
  IMI_ACTION_SET = IMI_BASE+108;
  IMI_ACTION_GETVALUE = IMI_BASE+106;
  IMI_ACTION_SETVALUE = IMI_BASE+110;
  IMI_GROUP_ACTIONSCOUNT = IMI_BASE+111;
  IMI_ACTION_EXISTS = IMI_BASE+112;
  IMI_ACTION_ISGROUP = IMI_BASE+113;
  IMI_ACTION_GETID = IMI_BASE+114;
  IMI_ACTION_REMOVE = IMI_BASE+115;
  IMI_ACTION_GETTYPE = IMI_BASE+116;
  IMI_GROUP_GETHANDLE = IMI_BASE+117;
  IMI_ACTION_FINDPARENT = IMI_BASE+118;
  IMI_GETPLUGINSGROUP = IMI_BASE+119;
  IMI_GROUP_MAKECFG = IMI_BASE+120;
  IMI_ACTION_SETCNT = IMI_BASE+121;
  IMI_ACTION_GETINDEX = IMI_BASE+122;
  IMI_ACTION_GETOWNER = IMI_BASE+123;
  IMI_ICONREGISTER = IMI_BASE+130;
  IMI_ACTION_MAKEPOPUPMENU = IMI_BASE+150;

  IMI_WARNING = IMI_BASE+200;
  IMI_ERROR = IMI_BASE+201;
  IMI_CONFIRM = IMI_BASE+202;
  IMI_INFORM = IMI_BASE+204;

  IM_PLUG_INIT = IM_BASE+1;
  IM_PLUG_DEINIT = IM_BASE+2;
  IM_PLUG_SDKVERSION = IM_BASE+20;

  IM_SETCOLS = IM_BASE+1001;
  
  NOTIFY_AUTO = -2;
  IMI_DLGPASS = IMI_BASE+205;
  IMI_DLGLOGIN = IMI_BASE+206;
  IMI_DLGSETPASS = IMI_BASE+207;
  IMI_DLGENTER = IMI_BASE+208;
  IMI_DLGBUTTONS = IMI_BASE+213;
  IMI_DLGTOKEN = IMI_BASE+214;
  IMI_LONGSTART = IMI_BASE+209;
  IMI_LONGEND = IMI_BASE+210;
  IMI_LONGSET = IMI_BASE+211;
  IMI_DLGPROFILE = IMI_BASE+212;
  IMI_NOTIFY = IMI_BASE+1010;
  IMI_NEWNOTIFY = IMI_BASE+1011;
  IMI_CNT_ACTIVITY = IMI_BASE+1013;
  IMI_CNT_DEACTIVATE = IMI_BASE+1014;
  IMI_CNT_DETAILS = IMI_BASE+1015;
  IMI_CNT_ISCOMPOSING = IMI_BASE+1020;

  IM_MSG_RCV = IM_BASE+100;
  IM_UI_PREPARE = IM_BASE+2000;
  IM_START = IM_BASE+2100;
  IM_END = IM_BASE+2101;
  IM_UIACTION = IM_BASE+2200;

  IM_PLUG_NET = IM_SHARE+10;
  IM_PLUG_TYPE = IM_SHARE+11;
  IM_PLUG_VERSION = IM_SHARE+12;
  IM_PLUG_SIG = IM_SHARE+13;
  IM_PLUG_CORE_V = IM_SHARE+14;
  IM_PLUG_UI_V = IM_SHARE+15;
  IM_PLUG_NAME = IM_SHARE+16;
  IM_PLUG_NETNAME = IM_SHARE+17;
  IM_PLUG_NETSHORTNAME = IM_SHARE+25;
  IM_PLUG_UIDNAME = IM_SHARE+26 ;

const
  IMIA_CNT_SEP = 131;

const
  IM_MSG_ok = 1;
  IM_MSG_delete = 2;
  IM_MSG_update = 4;
  IM_MSG_processing = 8;



type
  sDIALOGPtr = ^sDIALOG;
  sDIALOG = packed record
    s_size: Word;
    title: PChar; ///< Tytu okienka.
    info: PChar;  ///< Dodatkowa informacja ...
    flag: Integer;     ///< Flaga D*_
    handle: THandle; ///< Uchwyt do okna dialogowego. Przed utworzeniem okna, \a handle trzeba ustawi na rodzica okna!
    param: Pointer; ///< Parametr uzytkownika
  end;

type
  sDIALOG_accessPtr = ^sDIALOG_access;
  sDIALOG_access = packed record
    s_size: Word;
    title: PChar; ///< Tytu okienka.
    info: PChar;  ///< Dodatkowa informacja ...
    flag: Integer;     ///< Flaga D*_
    handle: THandle; ///< Uchwyt do okna dialogowego. Przed utworzeniem okna, \a handle trzeba ustawi na rodzica okna!
    param: Pointer; ///< Parametr uzytkownika
    pass:pchar;
    login:pchar;
    save:boolean;
  end;
function sDIALOG_accessB(): sDialog_access;

type
  sDIALOG_enterPtr = ^sDIALOG_enter;
  sDIALOG_enter = packed record
    s_size: Word;
    title: PChar; ///< Tytu okienka.
    info: PChar;  ///< Dodatkowa informacja ...
    flag: Integer;     ///< Flaga D*_
    handle: THandle; ///< Uchwyt do okna dialogowego. Przed utworzeniem okna, \a handle trzeba ustawi na rodzica okna!
    param: Pointer; ///< Parametr uzytkownika
    value: PChar;
    id: PChar;
    maxLength: Integer;
  end;
function sDIALOG_enterB(): sDialog_enter;

type
  sDIALOG_choosePtr = ^sDIALOG_choose;
  sDIALOG_choose = packed record
    s_size: Word;
    title: PChar; ///< Tytu okienka.
    info: PChar;  ///< Dodatkowa informacja ...
    flag: Integer;     ///< Flaga D*_
    handle: THandle; ///< Uchwyt do okna dialogowego. Przed utworzeniem okna, \a handle trzeba ustawi na rodzica okna!
    param: Pointer; ///< Parametr uzytkownika
    items: PChar;
    def: Integer;
    width: Integer;
  end;

function sDIALOG_chooseB(): sDIALOG_choose;

type
  sDIALOG_longPtr = ^sDIALOG_long;
  TcancelProc = function(dialog: sDIALOG_longPtr): Boolean; stdcall;
  TtimeoutProc = function(type_: Integer; dialog: sDIALOG_longPtr): Boolean;
  sDIALOG_long = packed record
    s_size: Word;
    title: PChar; ///< Tytu okienka.
    info: PChar;  ///< Dodatkowa informacja ...
    flag: Integer;     ///< Flaga D*_
    handle: THandle; ///< Uchwyt do okna dialogowego. Przed utworzeniem okna, \a handle trzeba ustawi na rodzica okna!
    param: Pointer; ///< Parametr uzytkownika
    progress: Integer; ///< Warto 'postpu'. Przy tworzeniu okna oznacza max. warto (liczon od zera) - domylnie 100.
    cancel: Boolean;  ///< Czy zostao wcinite [Anuluj]?
    threadId: Integer; ///< Id watku, z ktorego tworzone bylo okno
    cancelProc: TcancelProc; ///< Procedura wywoywana po naciniciu [Anuluj].
    timeoutProc: TtimeoutProc; ///< Procedura wywoywana aby sprawdzi czy nastpi timeout.
    timeoutParam: Pointer;  ///< Parametr do wykorzystania przez timeoutProc.
    timeout: Integer;          ///< Czas po jakim zostanie wysane TIMEOUTT_TIMEOUT.
    timeoutPassed: Integer;    ///< Ilo ms jaka uplyna od pierwszego TIMEOUTT_CHECK==0.
    timeoutHandle: THandle;
  end;

function sDIALOG_longB(): sDIALOG_long;

const
  DFLAG_SAVE = 1;
  DFLAG_PASS2 = 4;

const
  DLONG_MODAL = $01;
  DLONG_CANCEL = $02;
  DLONG_NODLG = $04;
  DLONG_SINGLE = $08;
  DLONG_ONLY = DLONG_SINGLE;
  DLONG_BLOCKING = $10;
  DLONG_ARECV = $200;

const
  DSET_TITLE = $1;    ///< Zosta zmieniony tytu.
  DSET_INFO = $2;    ///< Zostao zmienione info.
  DSET_PROGRESS = $4;    ///< Zosta zmieniony postp.
  DSET_BUTTONS = $8;    ///< Zostay zmienione flagi dotyczce przyciskw.
  DSET_ANIM = $10;   ///< Zostaa zmieniona animacja.

const
  IMC_LOG  = 1;
  IMC_CONNECTED = 7;
  IMC_SETCONNECT = 30;
  IMC_STATUSCHANGE = 246;
  IMC_PROFILEDIR = 12;
  IMC_NEWMESSAGE = 100;
  IMC_MESSAGEQUEUE = 101;
  IMC_PLUG_COUNT = 240;
  IMC_PLUG_HANDLE = 241;
  IMC_PLUG_VERSION = 26;
  IMC_PLUGID_POS = 245;
  IMC_CNT_COUNT = 201;
  IMC_PROFILESDIR = 23;
  IMC_GETPROFILE  = 2;
  IMC_FINDCONTACT = 200;
  IMC_FINDPLUG_BYSIG = 248;
  IMC_PLUG_ID = 243;
  IMC_CNT_ADD = 230 ;
  IMC_CNT_IGNORED = 310;
  IMC_RESTORECURDIR = 24;
  IMC_MESSAGEGET = 106;
  IMC_MESSAGEREMOVE = 104;
  IMC_MESSAGEWAITING = 103;
  IMC_ISWINXP = 60;

type
  sMESSAGESELECTPtr = ^sMESSAGESELECT;
  sMESSAGESELECT = packed record
    s_size: Word;
    net: Integer;
    uid: PChar;
    type_: Integer;
    wflag: Cardinal;
    woflag: Cardinal;
    id: Integer;
    position: Cardinal;
  end;

function sMESSAGESELECTB(): sMESSAGESELECT; overload;
function sMESSAGESELECTB(net: Integer; uid: PChar = nil; type_: Cardinal = Cardinal(-1); wflag: Cardinal = 0; woflag: Cardinal = 0): sMESSAGESELECT; overload;

const
  IMERROR_NORESULT = 1;   ///< Wtyczka nie obsuya wiadomoci.
  IMERROR_UNSUPPORTEDMSG = IMERROR_NORESULT; /// \no
  IMERROR_BADSENDER = 2;  ///< Wiadomo wstrzymana, pojawi si bd...
  IMERROR_BADPLUG = 3;    ///< Podana wtyczka nie istnieje.
  IMERROR_THREADSAFE = 4; ///< Wiadomo zostaa wywoana w trybie bezpiecznym (bez oczekiwania na powrt).
  IMERROR_SHUTDOWN = 5;   ///< Wiadomo zostaa anulowana z powodu zamykania programu.
  IMERROR_BADPARAM = 6;   ///< Nieprawidowe parametry.
  IMERROR_BADSTRUCT = 7;   ///< Niepoprawna struktura.

const
  IMT_ALL = $FFFFFFFF;
  IMT_CORE = 0;
  IMT_MESSAGE = 1;
  IMT_PROTOCOL = 2;
  IMT_CONTACT = 4;
  IMT_CONFIG = 8;
  IMT_UI = $10;
  IMT_NET = $20;
  IMT_NETSEARCH = $40;
  IMT_MSGUI = $80;
  IMT_NETUID = $100;
  IMT_ALLMESSAGES = $200;
  IMT_MESSAGEACK = $400;

const
  CNT_UID = 0; ///< #DT_CT_PCHAR UID.
  CNT_NET = 1; ///< #DT_CT_INT Sie.
  CNT_STATUS = 2; ///< #DT_CT_INT Status.
  CNT_BORN = 19;
  CNT_CELLPHONE = 9;
  CNT_LOCALITY = 13;
  CNT_CITY = CNT_LOCALITY;
  CNT_CLIENT = 15;
  CNT_CLIENTVERSION = 28;
  CNT_DISPLAY = 8;
  CNT_EMAIL = 11;
  CNT_GENDER = 20 ;
  CNT_GROUP = 21;
  CNT_HOST = 4;
  CNT_INFO = 12;
  CNT_INTERNAL = 24;
  CNT_LASTACTIVITY = 29;
  CNT_LASTMSG = 16;
  CNT_NAME = 6;
  CNT_NICK = 17;
  CNT_NOTIFY = 3;
  CNT_NOTIFY_MSG = 27;
  CNT_PHONE = 10;
  CNT_PORT = 5;
  CNT_POSTALCODE = 26;
  CNT_STATUS_ICON = 30;
  CNT_STATUSINFO = 18;
  CNT_SURNAME = 7;
  CNT_STREET = 25;
  CNT_COUNTRY = 14;
  CNT_FAX = 35;
  CNT_EMAIL_MORE = 32 ;
  CNT_URL = 36;
  CNT_DESCRIPTION = 34 ;
  CNT_MIDDLENAME = 31;

type fBeginThread = function(data: Pointer): Cardinal;

type
  cCtrlRPtr = ^cCtrlR;
  VMTPTR = ^VMT;
  TgetLevel = function(ptr: cCtrlRPtr): Integer; stdcall;
  TID = function(ptr: cCtrlRPtr): Cardinal; stdcall;
  ThInst = function(ptr: cCtrlRPtr): HINSTANCE; stdcall;
  ThDll = function(ptr: cCtrlRPtr): HINSTANCE; stdcall;
  TgetError = function(ptr: cCtrlRPtr): Integer; stdcall;
  TsetError = procedure(ptr: cCtrlRPtr; err_code: Integer); stdcall;
  TisRunning = function(ptr: cCtrlRPtr): Boolean; stdcall;
  TIMessage = function(ptr: cCtrlRPtr; msg: sIMessage_basePtr): Integer; stdcall;
  TIMessageDirect = function(ptr: cCtrlRPtr; plug: Cardinal; msg: sIMessage_basePtr): Integer; stdcall;
  TDTgetPos = function(ptr: cCtrlRPtr; db: tTable; row: Cardinal): Integer; stdcall;
  TDTgetID = function(ptr: cCtrlRPtr; db: tTable; row: Cardinal): Integer; stdcall;
  TDTgetOld = function(ptr: cCtrlRPtr; db: tTable; row: Cardinal; col: Cardinal): Integer; stdcall;
  TDTsetOld = function(ptr: cCtrlRPtr; db: tTable; row: Cardinal; col: Cardinal; val: Integer; mask: Integer = 0): Integer; stdcall;
  TDTgetType = function(ptr: cCtrlRPtr; db: tTable; id: Cardinal): Integer; stdcall;
  TDTgetCount = function(ptr: cCtrlRPtr; db: tTable): Integer; stdcall;
  TDTgetNameID = function(ptr: cCtrlRPtr; db: tTable; name: PChar): Integer; stdcall;
  TIs_TUS = function(ptr: cCtrlRPtr; thID: Cardinal): Cardinal; stdcall;
  TRecallTS = function(ptr: cCtrlRPtr; th: THandle = 0; wair: Boolean = True): Integer; stdcall;
  TRecallIMTS = function(ptr: cCtrlRPtr; th: THandle; wait: Boolean; msg: sIMessage_basePtr; plugID: Integer): Integer; stdcall;
  TWMProcess = procedure(ptr: cCtrlRPtr); stdcall;
  TGetTempBuffer = function(ptr: cCtrlRPtr; size: Cardinal): Pointer; stdcall;
  TDTget = function(ptr: cCtrlRPtr; db: tTable; row: Cardinal; col: Cardinal; value: sDTValuePtr): Boolean; stdcall;
  TDTset = function(ptr: cCtrlRPtr; db: tTable; row: Cardinal; col: Cardinal; value: sDTValuePtr): Boolean; stdcall;
  TDTlock = function(ptr: cCtrlRPtr; db: tTable; row: Cardinal; reserved: Integer = 0): Word; stdcall;
  TDTunlock = function(ptr: cCtrlRPtr; db: tTable; row: Cardinal; reserved: Integer = 0): Word; stdcall;
  Tmalloc = function(ptr: cCtrlRPtr; size: Cardinal): Pointer; stdcall;
  Tstrdup = function(ptr: cCtrlRPtr; str: PChar): PChar; stdcall;
  Tfree = procedure(ptr: cCtrlRPtr; buff: Pointer); stdcall;
  TSleep = function(ptr: cCtrlRPtr; time: Cardinal): Integer; stdcall;
  TBeginThread = function(ptr: cCtrlRPtr; security: Pointer; stack_size: Cardinal; start_address: fBeginThread; arglist: Pointer = nil; initflag: Cardinal = 0; thrdaddr: PCardinal = nil): THandle;stdcall;
  TDebugLevel = function(ptr: cCtrlRPtr; level: enDebugLevel = DBG_ALL): Cardinal; stdcall;
  TQuickShutdown = function(ptr: cCtrlRPtr): Boolean; stdcall;
  TSetDebugLevel = function(ptr: cCtrlRPtr; levelMask: enDebugLevel; level: enDebugLevel = DBG_ALL): Cardinal; stdcall;
  TDTgetName = function(ptr: cCtrlRPtr; db: tTable; col: Cardinal): PChar; stdcall;
  VMT = packed record
    getLevel: TgetLevel;
    ID: TID;
    hInst: ThInst;
    hDll: ThDll;
    getError: TgetError;
    setError: TsetError;
    isRunning: TisRunning;
    IMessage: TIMessage;
    IMessageDirect: TIMessageDirect;
    DTgetPos: TDTgetPos;
    DTgetID: TDTgetID;
    DTgetOld: TDTgetOld;
    DTsetOld: TDTsetOld;
    DTgetType: TDTgetType;
    DTgetCount: TDTgetCount;
    DTgetNameID: TDTgetNameID;
    Is_TUS: TIs_TUS;
    RecallTS: TRecallTS;
    RecallIMTS: TRecallIMTS;
    WMProcess: TWMProcess;
    GetTempBuffer: TGetTempBuffer;
    DTget: TDTget;
    DTset: TDTset;
    DTlock: TDTlock;
    DTunlock: TDTunlock;
    malloc: Tmalloc;
    strdup: Tstrdup;
    free: Tfree;
    Sleep: TSleep;
    BeginThread: TBeginThread;
    DebugLevel: TDebugLevel;
    QuickShutdown: TQuickShutdown;
    SetDebugLevel: TSetDebugLevel;
    DTgetName: TDTgetName;
  end;
  cCtrlR = packed record
    vptr: VMTPTR;
  end;

type
  cCtrlPtr = ^cCtrl;
  cCtrl = class
  private
    CtrlR: cCtrlRPtr;
  public
    constructor Create(p: Integer);
    function getLevel():Integer; stdcall;  ///< Zwraca "poziom" dostepu do rdzenia. W 99% przypadkw zwrci 1 ...
    function ID():Cardinal; stdcall;  ///< Zwraca identyfikator wtyczki.
    function hInst():HINSTANCE; stdcall;  ///<  Zwraca uchwyt procesu (HINSTANCE).
    function hDll():HINSTANCE; stdcall;   ///<  Zwraca uchwyt biblioteki wtyczki.

    function getError():Integer; stdcall; ///< Zwraca kod ostatniego bdu.
    procedure setError(err_code: Integer); stdcall; ///< Ustawia kod bdu.
                                                             ///  Powinien byc ustawiony gdy wystapil blad przy ODBIORZE wiadomosci (np wiadomosc jest nieobslugiwana).
                                                             ///  \sa ImessageProc() imerror_
    function isRunning():Boolean; stdcall; ///< Zwraca 0 jeli program jest w trakcie zamykania.
                                                    ///  adne dusze operacje nie powinny by wykonywane. Cz IMessages
                                                    ///  w innych moduach i tak nie zostanie wykonana...
    {
    Wysya wiadomo do wtyczek.
    Aby przesa wiadomo do rdzenia lub ui jako \i net i \i type trzeba poda 0
    \param msg Wiadomo do przesania
    \sa im_ net_ imt_
    }
    function IMessage(msg: sIMessage_basePtr):Integer; overload; stdcall;
    { Wysya wiadomo bezporednio do okrelonej wtyczki.
     \param msg Wiadomo do przesania
     \param plug ID wtyczki
     \sa im_ imc_plug_
    }
    function IMessageDirect(plug: Cardinal; msg: sIMessage_basePtr):Integer; overload; stdcall;
    { Zamienia (lub nie) identyfikator wiersza na jego numer.
    }
    function DTgetPos(db: tTable; row: Cardinal):Integer; stdcall;
    { Zamienia (lub nie) numer wiersza na jego identyfikator.
    }
    function DTgetID(db: tTable; row: Cardinal):Integer; stdcall;
    function DTgetOld(db: tTable; row: Cardinal; col: Cardinal):Integer; stdcall;
    function DTsetOld(db: tTable; row: Cardinal; col: Cardinal; val :Integer; mask: Cardinal=0):Integer; stdcall;
    { Pobieta typ kolumny \a id.
      \param id Identyfikator kolumny
      \return typ kolumny
      \sa \ref cfg dt_ct_
    }
    function DTgetType(db: tTable; id: Cardinal): Integer; stdcall;
    { Pobieta ilo wierszy w tablicy.
      \param db Identyfikator tablicy
      \sa \ref cfg dt_ct_
    }
    function DTgetCount(db: tTable): Integer; stdcall;
    { Pobieta identyfikator kolumny o podanej nazwie.
      \param db Identyfikator tablicy
      \param name nazwa kolumny
      \sa \ref cfg dt_ct_
    }
    function DTgetNameID(db: tTable; const name: PChar): Integer; stdcall;

    function Is_TUS(thID: Cardinal): Cardinal; stdcall; ///< Zwraca \a thID jeli aktualny wtek jest rny od \a thID. Lub 0 gdy s rwne. Jako \a thID mona poda 0 - zostanie zamienione na gwny wtek aplikacji.
    function RecallTS(th: THandle = 0; wait: Boolean = true):Integer; stdcall;
    function RecallIMTS(th: THandle; wait: Boolean; msg: sIMessage_basePtr; plugID:Integer):Integer; stdcall;

    procedure WMProcess(); stdcall; ///< Oprnienie kolejki wiadomoci windowsowych.
                                             ///  Powinno by wykonywane TYLKO w gwnym wtku, w dugich
                                             ///  blokujcych ptlach (aby odwiey wygld okien)
    function GetTempBuffer(size: Cardinal): Pointer; stdcall; ///< Zwraca wskanik do bufora tymczasowego o rozmiarze \a size.
                                                                       /// Bufor alokowany jest w kontekcie wtyczki i wtku.
                                                                       /// \attention Nie mona zwalnia tej pamici!

    { Pobiera wartosc wiersza z tablicy danych z konwersj typw.
      Konwersja odbywa si gdy sDTValue::type jest rny od DT_CT_UNKNOWN. W
      przeciwnym wypadku jako typ przyjmowany jest typ kolumny.
         \param db Identyfikator tabeli
         \param row Identyfikator/numer wiersza
         \param col Identyfikator kolumny
         \param value Struktura z wartoci
         \return warto (lub adres do wartoci jeli typ != DT_CT_INT)
         \attention W #DTMSG mona zapisywa tylko w okrelonych okolicznociach!
     }
     function DTget(db: tTable; row: Cardinal; col: Cardinal; value: sDTValuePtr): Boolean; stdcall;
     {  Ustawia wartosc wiersza z tablicy danych z konwersj typw.
         Konwersja odbywa si gdy sDTValue::type jest rny od DT_CT_UNKNOWN. W
         przeciwnym wypadku jako typ przyjmowany jest typ kolumny.
         \param db Identyfikator tabeli
         \param row Identyfikator/numer wiersza
         \param col Identyfikator kolumny
         \param value Struktura do ktrej zostanie zapisana warto.
         \attention Do odczytu danych z #DTMSG przygotowane s inne funkcje!
       }
     function DTset(db: tTable; row: Cardinal; col: Cardinal; value: sDTValuePtr):Boolean; stdcall;
     { Blokuje dostp do wiersza w tablicy dla innych wtkw. Zaraz po
       wykorzystaniu zabezpieczonych danych trzeba wywoa cCtrl::DTunlock z tymi
       samymi parametrami!
         \param db Identyfikator tabeli
         \param row Identyfikator/numer wiersza, lub -1 jeli chcemy zablokowa CA tablic
         \param reserved Zarezerwowane na pniej, musi by rwne 0.
         \return Ilo wczeniej zaoonych blokad.
     }
     function DTlock(db: tTable; row: Cardinal; reserved: Integer = 0): Byte; stdcall;
     { Odblokowuje dostp do wiersza w tablicy dla innych wtkw,
       zastrzeony wczeniej przy uyciu cCtrk::DTlock.
       \param db Identyfikator tabeli
       \param row Identyfikator/numer wiersza, lub -1 jeli chcemy zablokowa CA tablic
       \param reserved Zarezerwowane na pniej, musi by rwne 0.
       \return Ilo pozostaych blokad.
       \attention Po wykonaniu tej funkcji, wszystkie zwrcone wskaniki
       bezporednie mog by ju nieaktualne!
     }
     function DTunlock(db: tTable; row: Cardinal; reserved: Integer = 0): Byte; stdcall;
     { Wszystkie bufory wrzucane do API, eby mogby by zwolnione
       w innym module musz by zaalokowane ponisz funkcj. }
     function malloc(size: Cardinal): Pointer; stdcall;
     { Wszystkie bufory tekstowe wrzucane do API, eby mogby by zwolnione
       w innym module musz by zaalokowane ponisz funkcj. }
     function strdup(const str: PChar): PChar; stdcall;
     { Wszystkie bufory zaalokowane przez cCtrl::malloc i cCtrl::strdup
       powinny by zwolnione t funkcj. }
     procedure free(buff: Pointer); stdcall;

     { Uywanie zwykego Sleep w gwnym wtku najprdzej doprowadzi
       K do stanu chwilowej nieuywalnoci, bardzo moliwe rwnie,
       e nastpi zupeny DeadLock.
       Zamiast tego mona uywa tej funkcji, ktra po prostu zamiast Sleep
       wywouje MsgWaitForMultipleObjectsEx. Nie jest wic gwarantowane, 
       e podany czas w ogle minie. Trzeba pamita te, e nie jest gwarantowane,
       e aktualny wtek nie wykona gdzie po drodze innego kodu w wyniku
       wywoania f-cji APC, timer'a czy windowsowej wiadomoci...
       Podczas zamykania (w IM_END) nie powinny by wywoywane procedury APC ani
       przeczanie wtkw...
       Generalnie, jeeli musisz czeka na co w gwnym wtku, uywaj
       MsgWaitForMultipleObjectsEx w poczeniu z Ctrl->WMProcess, ktre
       przeglda kolejk oczekujcych wiadomoci w aktualnym wtku.
     }
     function Sleep(time: Cardinal): Integer; stdcall;

     {
       BeginThread dziaa identycznie jak _beginthreadex z wyjtkiem
       tego, e w trybie debug potrafi wychwytywa bdy w wtku
       i je raportowa... Uywanie wysoko zalecane!
       @warn Funkcja zwraca uchwyt wtku! Naley go zamkn przy pomocy CloseHandle()!!!
     }
     function BeginThread( security: Pointer;
      stack_size: Integer;
      start_address: fBeginThread;
      arglist: Pointer = nil;
      initflag: Cardinal = 0;
      thrdaddr: PCardinal = nil
     ): THandle; stdcall;
    {** Tworzy wtek i czeka a si skoczy.
      Parametry te same co w cCtrl::BeginThread()
    *}
    function BeginThreadAndWait(security: THandle;  stack_size: Cardinal; start_address: fBeginThread; arglist: THandle = 0; initflag: THandle = 0; thrdaddr: THandle = 0): Integer;

    { Pobiera poziom debugowania dla wtyczki }
    function DebugLevel(level: enDebugLevel = DBG_ALL): Integer; stdcall;

    { Podaje, czy Konnekt jest zamykany w trybie natychmiastowym (np. podczas zamykania systemu).
      Wtyczki nie powinny w tym czasie wykonywa dugich operacji, przecza wtkw (#IMESSAGE_TS),
      ani przetwarza procedur APC (flaga Alertable w funkcjach oczekujcych WinApi).
     }
    function QuickShutdown(): Boolean; stdcall;

    { Ustawia poziom debugowania wtyczki.
     }
    function SetDebugLevel(levelMask: enDebugLevel; level: enDebugLevel = DBG_ALL): Cardinal; stdcall;

    { Pobiera nazwe kolumny o podanym identyfikatorze.
         \param db Identyfikator tablicy
         \param col Identyfikator kolumny
         \sa \ref cfg dt_ct_
     }
    function DTgetName(db: tTable; col: Cardinal): PChar; stdcall;


         // funkcje lokalne, dla ulatwienia
         function DTgetInt(db: tTable; row: Cardinal; col: Cardinal): Integer; overload;
         function DTsetInt(db: tTable; row: Cardinal; col: Cardinal; value: Integer; mask: Integer = -1): Boolean; overload;
         function DTgetStr(db: tTable; row: Cardinal; col: Cardinal; buff: PChar = nil; size: Cardinal = 0): PChar; overload;
         function DTsetStr(db: tTable; row: Cardinal; col: Cardinal; const value: PChar): Boolean; overload;
         function DTgetInt64(db: tTable; row: Cardinal; col: Cardinal): Int64; overload;
         function DTsetInt64(db: tTable; row: Cardinal; col: Cardinal; value: Int64; mask: Int64 = -1): Boolean; overload;

         function DTgetInt(db: tTable; row: Cardinal; const name: PChar): Integer; overload;
         function DTsetInt(db: tTable; row: Cardinal; const name: PChar; value: Integer; mask: Integer = -1): Boolean; overload;
         function DTgetStr(db: tTable; row: Cardinal; const name: PChar; buff: PChar = nil; size: Cardinal = 0): PChar; overload;
         function DTsetStr(db: tTable; row: Cardinal; const name: PChar; const value: PChar): Boolean; overload;
         function DTgetInt64(db: tTable; row: Cardinal; const name: PChar): Int64; overload;
         function DTsetInt64(db: tTable; row: Cardinal; const name: PChar; value: Int64; mask: Int64 = -1): Boolean; overload;


    { Zapisuje sfromatowan informacj do pliku konnekt.log (i ew. wywietla j w oknie @Dev) }
    procedure IMLOG(const format: string; const arglist: array of const );
    { Loguje, jeeli wtyczka ma wczone logowanie na danym "poziomie" }
    procedure IMDEBUG(level: enDebugLevel; const format: string; const arglist: array of const);
    procedure IMLOG_(level: enDebugLevel; const format: string; const va_list: array of const);

    // ----
    function IMessage(id: Cardinal; net: Integer = 0; type_: Cardinal = Cardinal(-1); p1: Integer = 0; p2: Integer = 0): Integer; overload;
    function ICMessage(id: Cardinal; p1: Integer = 0; p2: Integer = 0): Integer;
    function IMessageDirect(id: Cardinal; plug: Cardinal = 0; p1: Integer = 0; p2: Integer = 0): Integer; overload;

    function UIActionInsert( _parent: Integer; _id: Integer; _pos: Integer; _status: Integer = 0; const _txt: PChar = nil; _p1: Integer = 0;  _w: Shortint = 0; _h: Shortint = 0; _p2: Integer = 0; _param: Integer = 0): Integer;

    function SetColumn(table: tTable; id: Integer; type_: Integer; def: Integer; const name: PChar): Integer; overload;
    function SetColumn(table: tTable; id: Integer; type_: Integer; const def: PChar; const name: PChar = nil):Integer; overload; {
      return this->SetColumn(table , id , type , (int)def , name);
    }
end;

{ Identyfikatory podstawowych akcji w UI tworzacych grupy}
const
  IMIG_MAINWND = 1;   ///< Gwne okno
  IMIG_BAR = 2;   ///< Belka glowna
  IMIG_MSGWND = 3;   ///< Okno wysyania wiadomoci
  IMIG_MSGBAR = 4;   ///< Belka w wysyaniu wiadomoci
  IMIG_MAINTB = 8;   ///< Gwny toolbar
  IMIG_SHORTCUTTB = 9;   ///< Toolbar ze skrtami
  IMIG_MAIN = 10;  ///< Gwne Menu
  IMIG_MAIN_OPTIONS = 11;  ///< Menu opcji
  IMIG_MAIN_CNT = 12;     ///< Dodaj kontakt
  IMIG_MAIN_PROFILE = 13;  ///< Profile
  IMIG_HISTORYWND = 14;
  IMIG_PLUGINS = 15;  { < Grupa dla ikonek wtyczek w gwnym oknie... Uytkownik moe wybra
                          inn, wic numer aktualnej grupy naley pobra przez #IMI_GETPLUGINSGROUP.
                      }
  IMIG_STATUS = 50;  ///< Toolbar ze statusami
  IMIG_EVENT = 51;  ///< Menu z wiadomociami od serwerw.
  IMIG_EVENT_PARENT = IMIG_STATUS;
  IMIG_HIDDEN = 60;

  IMIG_TRAY = 20;  ///< Tray
  IMIG_CNT = 30;  ///< Menu kontaktu
  IMIG_CFGWND = 40;  ///< Okno ustawie.
  IMIG_CFG = 41;  ///< Korze drzewka ustawie.
  IMIG_CFG_CONNECTION = 42; ///< Opcje pocze.
  IMIG_CFG_USER = 43;  ///< Ustawienia uytkownika.
  IMIG_CFG_SETTINGS = 44;  ///< Ustawienia programu.
  IMIG_CFG_UI = 45;  ///< Ustawienia interfejsu.
  IMIG_CFG_PLUGS = 46;  ///< Ustawienia wtyczek.

  IMIG_NFOWND = 70;  ///< Okno informacji o kontakcie
  IMIG_NFO = 71;   ///< Drzewko kontrolek informacji
  IMIG_NFO_BAR = 72;   ///< Belka w oknie informacji o kontakcie
  IMIG_NFO_TB = 73;   ///< Gwny toolbar w oknie informacji o kontakcie
  IMIG_MSGTB  = 200;
  IMIG_NFO_SAVE  = 400;
  IMIG_NFO_REFRESH  = 402;
  IMIG_NFO_DETAILS=410;
  IMIG_NFO_SUMMARY=413;

const
  ST_CONNECTING = $F1;
  ST_NA = $21;
  ST_DND = $22;
  ST_OCCUPIED = $22;
  ST_ONLINE = $40;
  ST_AWAY = $41;
  ST_AUTOAWAY = $44;
  ST_HIDDEN = $42;
  ST_CHAT = $43;
  ST_OFFLINE = 0;
  ST_IGNORE = $400;

const
  CFG_PROXY = 4 ;
  CFG_PROXY_AUTO = 15;
  CFG_PROXY_VERSION = 5;
  CFG_PROXY_AUTH = 6;
  CFG_PROXY_LOGIN = 7;
  CFG_PROXY_PASS = 8;
  CFG_PROXY_HOST = 9 ;
  CFG_PROXY_PORT = 10;
  CFG_PROXY_HTTP_ONLY = 21;
  CFG_APPDIR = 3;
  CFG_AUTO_CONNECT = 11;
  CFG_TIMEOUT  = 24;
  CFG_RETRY  = 20;




type
  cMessagePtr = ^cMessage;
  cMessage = packed record
    s_size: Word;
    id: Cardinal;
    net: Cardinal;
    type_: Cardinal;
    fromUid: PChar;
    toUid: PChar;
    body: PChar;
    ext: PChar;
    flag: Cardinal;
    action: sUIAction;
    notify: Cardinal;
    time: Int64;
end;

function cMessageB(): cMessage;

type
  cInsertMsgPtr = ^cInsertMsg;
  cInsertMsg = record
    actn: sUIActionNotify_base;
    _message: cMessagePtr;
    display: Pchar;
    scroll: Boolean;
end;

function cInsertMsgB(): cInsertMsg;

const
  IMI_MSG_EDITCTRL_WNDPROC = IMI_BASE+3005;
  IMI_HISTORY_ADD = IMI_BASE+3004;
type
  sHISTORYADDPtr = ^sHISTORYADD;
  sHISTORYADD = Packed Record
    s_size: Word;
    m: cMessagePtr;
    Dir: PChar;
    cnt: Cardinal;
    Name: PChar;
    session :Integer;
  end;

const
  EXT_PARAM = Chr($1A);

const
  MT_MASK_NOTONLIST = $1000;
  MT_MESSAGE = 1;
  MT_QUICKEVENT = 2;
  MT_CNTEVENT = 3;
  MT_EVENT = MT_CNTEVENT or MT_MASK_NOTONLIST;
  MT_SERVEREVENT = 4 or MT_MASK_NOTONLIST;
  MT_AUTHORIZE = 5;
  MT_CONFERENCE = 6;
  MT_FILE = 7;
  MT_MAIL = 8;
  MT_SMS = 9;
  MT_SOUND = 10;
  MT_URL = 11 or MT_MASK_NOTONLIST;
  MT_SPECIAL = 12;
  MT_SPECIAL_NOL =  13 or MT_MASK_NOTONLIST;
  MT_IMAGE = 15;
  MT_BOARD = 16;
  MT_MASK = $FFF;

const
  MF_SEND = 2;
  MF_NOEVENTS = 4;
  MF_NOSAVE = 8;
  MF_REQUESTOPEN = $10;
  MF_PROCESSING = $20;
  MF_OPENED = $40;
  MF_HANDLEDBYUI = $80;
  MF_AUTOMATED = $100;
  MF_HTML = $200;
  MF_MENUBYUI = $400;
  MF_LEAVEASIS = $800;
  MF_HIDE = $1000;
  MF_DONTADDTOHISTORY = $2000;
  MF_QE_NORMAL = $10000;
  MF_QE_SHOWTIME = $20000;

implementation

{ Implementacje funkcji uatwiajcych wypenianie struktury sIMessage_setColumn }
function sIMessage_setColumnB(table: tTable; id: Integer; type_: Integer; def: Integer; const name: PChar = nil): sIMessage_setColumn;
var
  col: sIMessage_setColumn;
begin
  col.size := SizeOf(sIMessage_setColumn);
  col.id := 1102;
  col.net := 0;
  col.type_ := 0;
  col.sender := 0;
  col.flag := 0;
  col.table := table;
  col._id := id;
  col._type := type_;
  col.def := def;
  col.name := name;
  Result := col;
end;

function sIMessage_setColumnB(table: tTable; id: Integer; type_: Integer; const def: PChar; const name: PChar = nil): sIMessage_setColumn;
var
  col: sIMessage_setColumn;
begin
  col.size := SizeOf(sIMessage_setColumn);
  col.id := 1102;
  col.net := 0;
  col.type_ := 0;
  col.sender := 0;
  col.flag := 0;
  col.table := table;
  col._id := id;
  col._type := type_;
  col.def := Integer(def);
  col.name := name;
  Result := col;
end;

function sIMessage_setColumnB(id: Integer; type_: Integer; def: Integer; const name: PChar = nil): sIMessage_setColumn;
var
  col: sIMessage_setColumn;
begin
  col.size := SizeOf(sIMessage_setColumn);
  col.id := 1102;
  col.net := 0;
  col.type_ := 0;
  col.sender := 0;
  col.flag := 0;
  col.table := DTCFG;
  col._id := id;
  col._type := type_;
  col.def := def;
  col.name := name;
  Result := col;
end;

function sIMessage_setColumnB(id: Integer; type_: Integer; const def: PChar; const name: PChar = nil): sIMessage_setColumn;
var
  col: sIMessage_setColumn;
begin
  col.size := SizeOf(sIMessage_setColumn);
  col.id := 1102;
  col.net := 0;
  col.type_ := 0;
  col.sender := 0;
  col.flag := 0;
  col.table := DTCFG;
  col._type := type_;
  col.def := Integer(def);
  col.name := name;
  Result := col;
end;

{ Implementacje funkcji uatwiajcych wypenianie struktury sIMessage_base }
function sIMessage_baseB(id: Cardinal; net: Integer; _type: Cardinal): sIMessage_base;
var
  msgBase: sIMessage_base;
begin
  msgBase.size := SizeOf(msgBase);
  msgBase.id := id;
  msgBase.net := net;
  msgBase.type_ := _type;
  msgBase.sender := 0;
  msgBase.flag := 0;
  Result := msgBase;
end;

function sIMessage_baseB(): sIMessage_base;
var
  msgBase: sIMessage_base;
begin
  msgBase.size := SizeOf(msgBase);
  msgBase.id := 0;
  msgBase.net := 0;
  msgBase.type_ := 0;
  msgBase.sender := 0;
  msgBase.flag := 0;
  Result := msgBase;
end;

function sIMessage_baseB(id: Cardinal): sIMessage_base;
var
    msgBase: sIMessage_base;
begin
  msgBase.size := SizeOf(msgBase);
  msgBase.id := id;
  msgBase.net := 0;
  msgBase.type_ := 0;
  msgBase.sender := 0;
  msgBase.flag := 0;
  Result := msgBase;
end;

function sIMessage_baseB(base: sIMessage_basePtr): sIMessage_base;
var
  msgBase: sIMessage_base;
begin
  msgBase := base^;
  Result := msgBase;
end;

{ Implementacje funkcji uatwiajcych wypenianie struktury sIMessage_2params }
function sIMessage_2paramsB(id: Cardinal; net: Integer; _type: Cardinal; p1: Integer; p2: Integer): sIMessage_2params;
var
  msg: sIMessage_2params;
begin
  msg.size := SizeOf(msg);
  msg.id := id;
  msg.flag := 0;
  msg.sender := 0;
  msg.net := net;
  msg.type_ := _type;
  msg.p1 := p1;
  msg.p2 := p2;
  Result := msg;
end;

function sIMessage_2paramsB(): sIMessage_2params;
var
  msg: sIMessage_2params;
begin
  msg.size := SizeOf(msg);
  msg.id := 0;
  msg.flag := 0;
  msg.sender := 0;
  msg.net := 0;
  msg.type_ := 0;
  msg.p1 := 0;
  msg.p2 := 0;
  Result := msg;
end;

function sIMessage_2paramsB(id: Cardinal; p1: Integer; p2: Integer): sIMessage_2params;
var
  msg: sIMessage_2params;
begin
  msg.size := SizeOf(msg);
  msg.id := id;
  msg.flag := 0;
  msg.sender := 0;
  msg.net := 0;
  msg.type_ := 0;
  msg.p1 := p1;
  msg.p2 := p2;
  Result := msg;
end;

function sIMessage_2paramsB(base: sIMessage_base): sIMessage_2params;
var
  msg: sIMessage_2params;
begin
  msg.size := SizeOf(msg);
  msg.id := base.id;
  msg.flag := base.flag;
  msg.sender := base.sender;
  msg.net := base.net;
  msg.type_ := base.type_;
  msg.p1 := 0;
  msg.p2 := 0;
  Result := msg;
end;

function sIMessage_UIMakePopupB(action :sUiAction; uFlags :Integer; x :Integer; y :Integer; nReserved :Integer; hWnd :Cardinal; prcRect :PRect; startFrom :Integer = 0):sIMessage_UIMakePopup;
var
  msg: sIMessage_UIMakePopup;
begin
  msg.size := SizeOf(msg);
  msg.id := IMI_ACTION_MAKEPOPUPMENU;
  msg.flag := 0;
  msg.sender := 0;
  msg.net := 0;
  msg.type_ := 0;
  msg._action := Action;
  msg._uFlags := uFlags;
  msg._x := x;
  msg._y := y;
  msg._nReserved := nReserved;
  msg._hWndMenu := hWnd;
  msg._startFrom := startFrom;
  msg.Rect := prcRect;
  Result := msg;
end;


{ Implementacje funkcji uatwiajcych wypenianie struktury sIMessage_2params }
function sUIActionInfoB(): sUIActionInfo;
var
  ai: sUIActionInfo;
begin
  ai.s_size := SizeOf(ai);
  ai.mask := 0;
  ai.act.id := 0;
  ai.act.parent := 0;
  ai.pos := 0;
  ai.handle := 0;
  Result := ai;
end;

function sUIActionInfoB(parent: Integer; id: Integer; pos: Integer; status: Integer = 0; txt: PChar = nil; p1: Integer = 0; w: Smallint = 0; h: Smallint = 0; p2: Integer = 0; param: Integer = 0): sUIActionInfo;
var
  ai: sUIActionInfo;
begin
  ai.s_size := SizeOf(ai);
  ai.mask := UIAIM_ALL;
  ai.act := sUIActionB(parent, id);
  ai.pos := pos;
  ai.txt := txt;
  ai.status := status;
  ai.statusMask := Cardinal(-1);
  ai.exStyleMask := 0;
  ai.p1 := p1;
  ai.p2 := p2;
  ai.param := param;
  ai.w := w;
  ai.h := h;
  Result := ai;
end;

function sUIActionInfoB(parent: Integer; id: Integer): sUIActionInfo;
var
  ai: sUIActionInfo;
begin
  ai.s_size := SizeOf(ai);
  ai.mask := 0;
  ai.act.id := id;
  ai.act.parent := parent;
  Result := ai;
end;

function sUIActionInfoB(a: sUIAction): sUIActionInfo;
var
  ai: sUIActionInfo;
begin
  ai.s_size := SizeOf(ai);
  ai.act := a;
  ai.mask := 0;
  Result := ai;
end;

{ Implementacja metod klasy cCtrl }

constructor cCtrl.Create(p: Integer);
begin
  inherited Create();
  self.CtrlR := cCtrlRPtr(p);
end;

function cCtrl.getLevel():Integer;
begin
  Result := CtrlR.vptr.getLevel(CtrlR);
end;

function cCtrl.ID():Cardinal;
begin
  Result := CtrlR.vptr.ID(CtrlR);
end;

function cCtrl.hInst():HINSTANCE;
begin
  Result := CtrlR.vptr.hInst(CtrlR);
end;

function cCtrl.hDll():Cardinal;
begin
  Result := CtrlR.vptr.hDll(CtrlR);
end;

function cCtrl.getError():Integer;
begin
  Result := CtrlR.vptr.getError(CtrlR);
end;

procedure cCtrl.setError(err_code: Integer);
begin
  CtrlR.vptr.setError(CtrlR, err_code);
end;

function cCtrl.isRunning(): Boolean;
begin
  Result := CtrlR.vptr.isRunning(CtrlR);
end;

function cCtrl.IMessage(msg: sIMessage_basePtr): Integer;
begin
  Result := CtrlR.vptr.IMessage(CtrlR, msg);
end;

function cCtrl.IMessageDirect(plug: Cardinal; msg: sIMessage_basePtr):Integer;
begin
  Result := CtrlR.vptr.IMessageDirect(CtrlR, plug, msg);
end;

function cCtrl.DTgetPos(db: tTable; row: Cardinal):Integer;
begin
  Result := CtrlR.vptr.DTgetPos(CtrlR, db, row);
end;

function cCtrl.DTgetID(db: tTable; row: Cardinal): Integer;
begin
  Result := CtrlR.vptr.DTgetID(CtrlR, db, row);
end;

function cCtrl.DTgetOld(db: tTable; row: Cardinal; col: Cardinal): Integer;
begin
  Result := CtrlR.vptr.DTgetOld(CtrlR, db, row, col);
end;

function cCtrl.DTsetOld(db: tTable; row: Cardinal; col: Cardinal; val :Integer; mask: Cardinal=0):Integer;
begin
  Result := CtrlR.vptr.DTsetOld(CtrlR, db, row, col, val, mask);
end;

function cCtrl.DTgetType(db: tTable; id: Cardinal): Integer;
begin
  Result := CtrlR.vptr.DTgetType(CtrlR, db, id);
end;

function cCtrl.DTgetCount(db: tTable): Integer;
begin
  Result := CtrlR.vptr.DTgetCount(CtrlR, db);
end;

function cCtrl.DTgetNameID(db: tTable; const name: PChar): Integer;
begin
  Result := CtrlR.vptr.DTgetNameID(CtrlR, db, name);
end;

function cCtrl.Is_TUS(thID: Cardinal): Cardinal;
begin
  Result := CtrlR.vptr.Is_TUS(CtrlR, thID);
end;

function cCtrl.RecallTS(th: Cardinal = 0; wait: Boolean = True): Integer;
begin
  Result := CtrlR.vptr.RecallTS(CtrlR, th, wait);
end;

function cCtrl.RecallIMTS(th: THandle; wait: Boolean; msg: sIMessage_basePtr; plugID:Integer):Integer;
begin
  Result := CtrlR.vptr.RecallIMTS(CtrlR, th, wait, msg, plugID);
end;

procedure cCtrl.WMProcess();
begin
  CtrlR.vptr.WMProcess(CtrlR);
end;

function cCtrl.GetTempBuffer(size: Cardinal): Pointer;
begin
  Result := CtrlR.vptr.GetTempBuffer(CtrlR, size);
end;

function cCtrl.DTget(db: tTable; row: Cardinal; col: Cardinal; value: sDTValuePtr): Boolean;
begin
  Result := CtrlR.vptr.DTget(CtrlR, db, row, col, value);
end;

function cCtrl.DTset(db: tTable; row: Cardinal; col: Cardinal; value: sDTValuePtr):Boolean;
begin
  Result := CtrlR.vptr.DTset(CtrlR, db, row, col, value);
end;

function cCtrl.DTlock(db: tTable; row: Cardinal; reserved: Integer = 0): Byte;
begin
  Result := CtrlR.vptr.DTlock(CtrlR, db, row, reserved);
end;

function cCtrl.DTunlock(db: tTable; row: Cardinal; reserved: Integer = 0): Byte;
begin
  Result := CtrlR.vptr.DTunlock(CtrlR, db, row, reserved);
end;

function cCtrl.malloc(size: Cardinal): Pointer;
begin
  Result := CtrlR.vptr.malloc(CtrlR, size);
end;

function cCtrl.strdup(const str: PChar): PChar;
begin
  Result := CtrlR.vptr.strdup(CtrlR, str);
end;

procedure cCtrl.free(buff: Pointer);
begin
  CtrlR.vptr.free(CtrlR, buff);
end;

function cCtrl.Sleep(time: Cardinal): Integer;
begin
  Result := CtrlR.vptr.Sleep(CtrlR, time);
end;

function cCtrl.BeginThread( security: Pointer;
      stack_size: Integer;
      start_address: fBeginThread;
      arglist: Pointer = nil;
      initflag: Cardinal = 0;
      thrdaddr: PCardinal = nil
     ): THandle;
begin
  IsMultiThread := TRUE;
  Result := CtrlR.vptr.BeginThread(CtrlR, security, stack_size, start_address, arglist, initflag, thrdaddr);
end;

function cCtrl.DebugLevel(level: enDebugLevel = DBG_ALL): Integer;
begin
  Result := CtrlR.vptr.DebugLevel(CtrlR, level);
end;

function cCtrl.QuickShutdown(): Boolean;
begin
  Result := CtrlR.vptr.QuickShutdown(CtrlR);
end;

function cCtrl.SetDebugLevel(levelMask: enDebugLevel; level: enDebugLevel = DBG_ALL): Cardinal;
begin
  Result := CtrlR.vptr.SetDebugLevel(CtrlR, levelMask, level);
end;

function cCtrl.DTgetName(db: tTable; col: Cardinal): PChar;
begin
  Result := CtrlR.vptr.DTgetName(CtrlR, db, col);
end;

function cCtrl.SetColumn(table: tTable; id: Integer; type_: Integer; const def: PChar; const name: PChar = nil): Integer;
var
  idef: Integer;
begin
  idef := Integer(def);
  Result := SetColumn( table, id, type_, idef, name );
end;

function cCtrl.BeginThreadAndWait(security: THandle; stack_size: Cardinal; start_address: fBeginThread; arglist: THandle = 0; initflag: THandle = 0; thrdaddr: THandle = 0): Integer;
begin
  Result:=0;
end;

function cCtrl.DTgetInt(db: tTable; row: Cardinal; col: Cardinal): Integer;
var
  v: sDTValue;
begin
  v.type_ := DT_CT_INT;
  DTget( db, row, col, @v);
  Result := v.vInt;
end;

function cCtrl.DTsetInt(db: tTable; row: Cardinal; col: Cardinal; value: Integer; mask: Integer = -1): Boolean;
var
  v: sDTValue;
begin
  v.type_ := DT_CT_INT;
  if mask <> -1 then // maskowanie
  begin
    DTget( db, row, col, @v);
    v.vInt := ((v.vInt and not mask) or value);
    Result := DTset( db, row, col, @v);
  end
  else
  begin
    v.vInt := value;
    Result := DTset( db, row, col, @v);
  end;
end;

function cCtrl.DTgetStr(db: tTable; row: Cardinal; col: Cardinal; buff: PChar = nil; size: Cardinal = 0): PChar;
var
  v: sDTValue;
begin
  v.type_ := DT_CT_PCHAR;
  v.vChar := buff;
  v.buffSize := size;
  DTget(db, row, col, @v);
  Result := v.vChar;
end;

function cCtrl.DTsetStr(db: tTable; row: Cardinal; col: Cardinal; const value: PChar): Boolean;
var
  v: sDTValue;
begin
  v.type_ := DT_CT_PCHAR;
  v.vChar := value;
  Result := DTset(db, row, col, @v);
end;

function cCtrl.DTgetInt64(db: tTable; row: Cardinal; col: Cardinal): Int64;
var
  v: sDTValue;
begin
  v.type_ := DT_CT_64;
  DTget(db, row, col, @v);
  Result := v.vInt64;
end;

function cCtrl.DTsetInt64(db: tTable; row: Cardinal; col: Cardinal; value: Int64; mask: Int64 = -1): Boolean;
var
  v: sDTValue;
begin
  v.type_ := DT_CT_64;
  if mask <> -1 then  // maskowanie
  begin
    DTget(db, row, col, @v);
    v.vInt64 := ((v.vInt64 and not mask) or value);
    Result := DTset(db, row, col, @v);
  end
  else
  begin
    v.vInt64 := value;
    Result := DTset(db, row, col, @v);
  end;
end;

function cCtrl.DTgetInt(db: tTable; row: Cardinal; const name: PChar): Integer;
begin
  Result := DTgetInt(db, row, DTgetNameID(db, name));
end;

function cCtrl.DTsetInt(db: tTable; row: Cardinal; const name: PChar; value: Integer; mask: Integer = -1): Boolean;
begin
  Result := DTsetInt(db, row, DTgetNameID(db, name), value, mask);
end;

function cCtrl.DTgetStr(db: tTable; row: Cardinal; const name: PChar; buff: PChar = nil; size: Cardinal = 0): PChar;
begin
  Result := DTgetStr(db, row, DTgetNameID(db, name), buff, size);
end;

function cCtrl.DTsetStr(db: tTable; row: Cardinal; const name: PChar; const value: PChar): Boolean;
begin
  Result := DTsetStr(db, row, DTgetNameID(db, name), value);
end;

function cCtrl.DTgetInt64(db: tTable; row: Cardinal; const name: PChar): Int64;
begin
  Result := DTgetInt64(db, row, DTgetNameID(db, name));
end;

function cCtrl.DTsetInt64(db: tTable; row: Cardinal; const name: PChar; value: Int64; mask: Int64 = -1): Boolean;
begin
  Result := DTsetInt64(db, row, DTgetNameID(db, name), value, mask);
end;

procedure cCtrl.IMLOG(const format: string; const arglist: array of const );
begin
  self.IMLOG_(DBG_LOG, format, arglist);
end;

procedure cCtrl.IMDEBUG(level: enDebugLevel; const format: string; const arglist: array of const);
begin
  if self.DebugLevel(level) <> 0 then
  begin
    self.IMLOG_(level, format, arglist);
  end;
end;

procedure cCtrl.IMLOG_(level: enDebugLevel; const format: string; const va_list: array of const);
var
  msg: sIMessage_2params;
  buff: string;
begin
  FmtStr(buff, format, va_list);
  msg := sIMessage_2paramsB(IMC_LOG, Integer(PChar(buff)), Integer(level));
  self.IMessage(@msg);
end;

function cCtrl.IMessage(id: Cardinal; net: Integer = 0; type_: Cardinal = Cardinal(-1); p1: Integer = 0; p2: Integer = 0): Integer;
var
  msg: sIMessage_2params;
begin
  msg := sIMessage_2paramsB(id, net, type_, p1, p2);
  Result := self.IMessage(@msg);
end;

function cCtrl.ICMessage(id: Cardinal; p1: Integer = 0; p2: Integer = 0): Integer;
var
  msg: sIMessage_2params;
begin
  msg := sIMessage_2paramsB(id, 0, 0, p1, p2);
  Result := self.IMessage(@msg);
end;

function cCtrl.IMessageDirect(id: Cardinal; plug: Cardinal = 0; p1: Integer = 0; p2: Integer = 0): Integer;
var
  msg: sIMessage_2params;
begin
  if plug = 0 then
    plug := self.ID();
  msg := sIMessage_2paramsB(id, 0, 0, p1, p2);
  Result := self.IMessageDirect(plug, @msg);
end;

function cCtrl.UIActionInsert( _parent: Integer; _id: Integer; _pos: Integer; _status: Integer = 0; const _txt: PChar = nil; _p1: Integer = 0;  _w: Shortint = 0; _h: Shortint = 0; _p2: Integer = 0; _param: Integer = 0): Integer;
var
 ai: sUIActionInfo;
begin
  ai := sUIActionInfoB(_parent , _id , _pos , _status , _txt , _p1 , _w , _h , _p2 , _param);
  Result := self.ICMessage(IMI_ACTION , Integer(@ai) , 0);
end;

function cCtrl.SetColumn(table: tTable; id: Integer; type_: Integer; def: Integer; const name: PChar): Integer;
var
  sc: sIMessage_setColumn;
begin
  sc := sIMessage_setColumnB(table, id, type_, def, name);
  Result := self.IMessage(@sc);
end;

function sUIActionInfo_cfgB(): sUIActionInfo_cfg;
var
  ai: sUIActionInfo_cfg;
begin
  ai.s_size := SizeOf(ai);
  ai.mask := 0;
  ai.act.id := 0;
  ai.act.parent := 0;
  ai.pos := 0;
  ai.handle := 0;
  ai.x := 0;
  ai.y := 0;
  Result := ai;
end;

function sUIActionInfo_cfgB(parent: Integer; id: Integer; pos: Integer = -1; status: Integer = 0; txt: PChar = nil; col: Integer = 0; w: Smallint = 0; h: Smallint = 0; p2: Integer = 0; param: Integer = 0): sUIActionInfo_cfg;
var
  ai: sUIActionInfo_cfg;
begin
  ai.s_size := SizeOf(ai);
  ai.mask := UIAIM_ALL;
  ai.act.id := id;
  ai.act.parent := parent;
  ai.pos := pos;
  ai.txt := txt;
  ai.status := status;
  ai.statusMask := Cardinal(-1);
  ai.exStyleMask := 0;
  ai.p1 := col;
  ai.p2 := p2;
  ai.param := param;
  ai.w := 0;
  ai.h := 0;
  ai.w := 0;
  ai.h := 0;
  Result := ai;
end;

function sUIActionInfo_cfgB(parent: Integer; id: Integer; pos: Integer = -1; status: Integer = 0; txt: PChar = nil; col: Integer = 0; x: Smallint = 0; y: Smallint = 0; w: Smallint = 0; h: Smallint = 0; p2: Integer = 0; param: Integer = 0): sUIActionInfo_cfg; overload;
var
  ai: sUIActionInfo_cfg;
begin
  ai.s_size := SizeOf(ai);
  ai.mask := UIAIM_ALL;
  ai.act.id := id;
  ai.act.parent := parent;
  ai.pos := pos;
  ai.txt := txt;
  ai.status := status;
  ai.statusMask := Cardinal(-1);
  ai.exStyleMask := 0;
  ai.p1 := col;
  ai.p2 := p2;
  ai.param := param;
  ai.w := w;
  ai.h := h;
  ai.x := x;
  ai.y := y;
  Result := ai;
end;

const
  sd_info = '';

function sDIALOG_accessB(): sDIALOG_access;
var
  sde: sDIALOG_access;
begin
  sde.s_size := SizeOf(sde);
  sde.info := sd_info;
  sde.title := sd_info;
  sde.handle := 0;
  sde.param := nil;
  sde.pass:=sd_info;
  sde.login:=sd_info;
  sde.save:=false;
  result:=sde;
end;

const
  sde_val: PChar = '';
  sde_id: PChar = '';
function sDIALOG_enterB(): sDIALOG_enter;
var
  sde: sDIALOG_enter;
begin
  sde.s_size := SizeOf(sde);
  sde.info := sd_info;
  sde.title := sd_info;
  sde.handle := 0;
  sde.param := nil;
  sde.value := sde_val;
  sde.id := sde_id;
  sde.maxLength := 0;
  Result := sde;
end;

const
  sdc_items: PChar = '';
function sDIALOG_chooseB(): sDIALOG_choose;
var
  sdc: sDIALOG_choose;
begin
  sdc.s_size := SizeOf(sdc);
  sdc.info := sd_info;
  sdc.title := sd_info;
  sdc.handle := 0;
  sdc.param := nil;
  sdc.items := sdc_items;
  sdc.def := 1;
  sdc.width := 0;
  Result := sdc;
end;

function sDIALOG_longB(): sDIALOG_long;
var
  sdl: sDIALOG_long;
begin
  sdl.s_size := SizeOf(sdl);
  sdl.info := sd_info;
  sdl.title := sd_info;
  sdl.handle := 0;
  sdl.param := nil;
  sdl.progress := -1;
  sdl.cancel := False;
  sdl.cancelProc := nil;
  sdl.timeoutProc := nil;
  sdl.timeout := 0;
  sdl.timeoutPassed := 0;
  sdl.timeoutHandle := 0;
  sdl.timeoutParam := nil;
  sdl.threadId := 0;
  Result := sdl;
end;

function sUIActionB(): sUIAction;
var
  act: sUIAction;
begin
  act.parent := 0;
  act.id := 0;
  act.cnt := AC_CURRENT;
  Result := act;
end;

function sUIActionB(parent: Cardinal; id: Cardinal; cnt: Integer = AC_CURRENT): sUIAction;
var
  act: sUIAction;
begin
  act.parent := parent;
  act.id := id;
  act.cnt := cnt;
  Result := act;
end;

function sDTValueB(type_: Smallint = DT_CT_UNKNOWN): sDTValue;
var
  v: sDTValue;
begin
  v.type_ := type_;
  v.vInt64 := 0;
  v.buffSize := 0;
  Result := v;
end;

function cMessageB(): cMessage;
var
  m: cMessage;
begin
  m.s_size := SizeOf(m);
  m.id := 0;
  m.net := 0;
  m.flag := 0;
  m.type_ := 0;
  m.notify := 0;
  m.time := 0;
  m.action := sUIActionB(0,0);
  m.fromUid := '';
  m.toUid := '';
  m.body := '';
  m.ext := '';
  Result := m;
end;

function cInsertMsgB(): cInsertMsg;
var
  m: cInsertMsg;
begin
  m._message.s_size := SizeOf(m);
  m._message.id := 0;
  m._message.net := 0;
  m._message.flag := 0;
  m._message.type_ := 0;
  m._message.notify := 0;
  m._message.time := 0;
  m._message.action := sUIActionB(0,0);
  m._message.fromUid := '';
  m._message.toUid := '';
  m._message.body := '';
  m._message.ext := '';
  m.display := '';
  m.scroll := False;
  Result := m;
end;



function sMESSAGESELECTB(): sMESSAGESELECT;
var
  s: sMESSAGESELECT;
begin
  s.s_size := SizeOf(s);
  s.net := NET_BC;
  s.uid := nil;
  s.type_ := -1;
  s.wflag := 0;
  s.woflag := 0;
  s.id := -1;
  s.position := 0;
  Result := s;
end;

function sMESSAGESELECTB(net: Integer; uid: PChar = nil; type_: Cardinal = Cardinal(-1); wflag: Cardinal = 0; woflag: Cardinal = 0): sMESSAGESELECT; overload;
var
  s: sMESSAGESELECT;
begin
  s.s_size := SizeOf(s);
  s.net := net;
  s.uid := uid;
  s.type_ := type_;
  s.wflag := wflag;
  s.woflag := woflag;
  s.id := -1;
  s.position := 0;
  Result := s;
end;

end.
