library Msgs;

{  MSGS.CPP
   Przykadowa wtyczka dla programu Konnekt...
   Idealny sposb eby zacz pisa co swojego ...

   Przykady:
    -> wprowadzanie wiadomoci do kolejki
    -> obsuga wiadomoci
    -> sprawdzanie kolejki wiadomoci

   Jest to bardzo prosty przykad wykorzystania kolejki wiadomoci...
   By moe w nastpnych edycjach SDK zostanie on rozszerzony...

   Powinna zosta skompilowana jako Win32DLL z wykorzystaniem
   wielowtkowej wersji biblioteki CRT!

   (c)2002 hao | Stamina
   (c)2005 Winthux
   http://www.konnekt.info
}



uses
  Plug in '..\..\api\plug.pas',
  PlugDefs in '..\..\api\plugdefs.pas',
  ui in '..\..\api\ui.pas',
  PlugFunc in '..\..\api\plugfunc.pas',
  SysUtils;

{$R *.res}

const
  IMIG_EXAMPLE = 5100;
  IMIA_EXAMPLE_MGG = 5101;
  IMIA_EXAMPLE_MSG = 5102;
  IM_EX_TEST = 5000; // Identyfikator wiadomoci ktry wylemy do actcfg.cpp
  MT_EXAMPLE = 500;
  NET_EXAMPLE = 5; // Wartosc net tej wtyczki

const
  version: PChar = '';
  name: PChar = 'Msgs.dpr';
  sig: PChar = 'EX3';


function IPrepare(): Integer;
begin
  { Tutaj rejestrujemy sie w interfejsie }
  { Mowa bya ju o tym w actcfg.cpp wic nie bd si powtarza... Tym razem stworzymy sobie osobny toolbar!}
  UIGroupAdd(IMIG_BAR , IMIG_EXAMPLE, 0, 'msgs.dpr');
  UIActionAdd(IMIG_EXAMPLE , IMIA_EXAMPLE_MSG , 0 , 'MSG', UIIcon(IT_MESSAGE,0,MT_SERVEREVENT,0),40,40); // Ta akcja wstawi do kolejki "nasz" wiadomo...
  UIActionAdd(IMIG_EXAMPLE , IMIA_EXAMPLE_MGG , 0 , 'GG', UIIcon(IT_MESSAGE,0,MT_MESSAGE,0),40,40); // a ta wrzuci wiadomo od kontaktu z UID 1 na GG
  // pamitaj eby wczy przyjmowanie wiadomoci od osb spoza listy!
  Result := 1;
end;

function ActionProc(const anBase: sUIActionNotify_basePtr): Integer;
{ Tutaj obsugujemy akcje }
  {  Ponisza linijka suy TYLKO waszej wygodzie!
     Wikszo (o ile nie wszystkie) powiadomie przesyana jest jako sUIActionNotify_2params,
     korzystamy wtedy z obiektu an, w przeciwnym razie z anBase, lub castujemy do spodziewanego typu.
  }
var
  an: sUIActionNotify_2paramsPtr;
  m: cMessage;
  ms: sMESSAGESELECT;
begin
  an := sUIActionNotify_2paramsPtr(anBase);

  case (anBase.act.id) of
    IMIA_EXAMPLE_MGG:
      begin
        if ACTIONONLY(anBase) then
        begin
          m := cMessageB();
          m.flag := MF_HANDLEDBYUI; // Wiadomo zostanie obsuona w caoci przez UI
          m.fromUid := '1';
          m.toUid := ''; // Wiadomo ma przyj, czyli jest do nas, czyli nie wpisujemy nic...
          m.net := NET_GG;
          m.time := 0; // Czas podajemy w formacie cTime64 - jest to mj wasny format  i udostpnie
              // obsugujc go bibliotek razem z nastpnym SDK...
              // Format jest podobny jak tm co do iloci pl, tyle e upycha je wszystkie w 64 bitach...
              // Nie zastosowaem zwykego time_t bo jest dosy "krtki" , a time64_t obsuguje tylko MSVC ...
          m.type_ := MT_MESSAGE;
          m.body := 'HELLO WORLD!'; // Tre
          m.ext := ''; // Dodatkowe info... na razie pusto
          ms := sMESSAGESELECTB();
          ms.id := ICMessage(IMC_NEWMESSAGE , Integer(@m));
          // w ms.id dostalimy ID dodanej wiadomoci...
          // po dodaniu wiadomoci ZAWSZE trzeba przejrze kolejk...
          // w sMESSAGESELECT podajemy jakie wiadomoci doszy...
          // ustawiajc tylko ms.id MessageQueue zostanie sprawdzone pod ktem tylko tej jednej
          // wiadomoci... Trzeba jednak sprawdzi czy wiadomo zostaa w ogle dodana do
          // kolejki...
          if (ms.id <> 0) then
            ICMessage(IMC_MESSAGEQUEUE, Integer(@ms));
        end;
      end;
    IMIA_EXAMPLE_MSG:
      begin
        if ACTIONONLY(anBase) then
        begin
          m := cMessageB();
          m.flag := 0; // Wiadomo zostanie obsuona w caoci przez UI
          m.fromUid := 'msgs.cpp';
          m.toUid := ''; // Wiadomo ma przyj, czyli jest do nas, czyli nie wpisujemy nic...
          m.net := NET_EXAMPLE;
          m.time := 0;
          m.type_ := MT_EXAMPLE or MT_MASK_NOTONLIST; // Nasz typ wiadomoci... MT_MASK_NOTONLIST oznacza, e rdze nie sprawdzi od kogo przysza wiadomo...
          m.body := 'HELLO WORLD!'; // Tre
          m.ext := ''; // Dodatkowe info... na razie pusto
          ICMessage(IMC_NEWMESSAGE, Integer(@m));
          {   Teraz zostanie wywoane IM_MSG_RCV na ktry zwrcimy IM_MSG_delete...
              Wywoywanie IMC_MESSAGEQUEUE nie ma wic sensu...

              Pena obsuga wiadomoci, cznie z oczekiwaniem na odbir wymagaaby
              zwrcenia IM_MSG_ok przy zapytaniu IM_MSG_RCV, co przydzielioby wiadomo
              do naszej wtyczki, a nastpnie obsugi IM_MSG_OPEN ktrego mechanizm
              najlepiej rozwiza w sposb taki:
                (Dla uproszczenia zamy e wiadomo jest wiadomoci "od serwera", czyli
                 e nie pojawi si na licie kontaktw...)
                - w IM_MSG_OPEN sprawdzamy czy jest utworzone okno, w ktrym ma pojawi si wiadomo
                   tak -> wypisujemy wiadomo w oknie i zwracamy IM_MSG_delete
                   nie -> zwracamy 0...
                - w odpowiedzi na nasz akcj np. "odbierz wiadomo" tak na prawd tworzymy tylko
                  okno i wywoujemy IMC_MESSAGEQUEUE ... Mona oczywicie te przejrze list rcznie...
                  jak kto woli...
              }
        end;
      end;
  end;
  Result := 0;
end;

function IMessageProc(const msgBase: sIMessage_basePtr): Integer; stdcall;
var
  msg: sIMessage_2paramsPtr;
  ret: Integer;
  m: cMessagePtr;
  buff: string;

begin
  msg := sIMessage_2paramsPtr(msgBase);
  ret := -1;

  case msgBase.id of
    { Wiadomoci na ktre TRZEBA odpowiedzie }
    IM_PLUG_NET: ret := NET_EXAMPLE;  // Zwracamy warto NET, ktra MUSI by rna od 0!
    IM_PLUG_TYPE: ret := IMT_UI or IMT_MESSAGE or IMT_MSGUI;   // Zwracamy jakiego typu jest nasza wtyczka (ktre wiadomoci bdziemy obsugiwa)
    IM_PLUG_VERSION: ret := Integer(version); // Wersja wtyczki tekstowo major.minor.release.build ..., lub 0 jeeli wersja zapisana jest w zasobach DLLa
    IM_PLUG_SDKVERSION: ret := KONNEKT_SDK_V; // Ta linijka jest wymagana!
    IM_PLUG_SIG: ret :=  Integer(sig); // Sygnaturka wtyczki (krtka, kilkuliterowa nazwa)
    IM_PLUG_NAME: ret := Integer(name); // Pena nazwa wtyczki (ale najlepiej nie za duga!)
    IM_PLUG_NETNAME: ret := 0; // Nazwa obsugiwanej sieci (o ile jak sie obsuguje)
    IM_PLUG_INIT: ret := Plug_Init(msg.p1, msg.p2);
    IM_PLUG_DEINIT: Plug_Deinit(msg.p1, msg.p2);

    IM_UI_PREPARE: ret := IPrepare();

    IM_UIACTION: ret := ActionProc(sUIActionNotify_basePtr(msg.p1));
    IM_MSG_RCV:
      begin
        m := cMessagePtr(msg.p1);
        { Bierzemy tylko wiadomo "naszego" typu }
        if (m.type_ = (MT_EXAMPLE or MT_MASK_NOTONLIST)) then
        begin
          FmtStr(buff, 'Dostaem wiadomo od %s:'#10#10'%s', [m.fromUid, m.body]);
          ICMessage(IMI_INFORM , Integer(PChar(buff)));
          ret := IM_MSG_delete;
        end
        else
          ret := 0;
        end;
  end;

  { Tutaj obsugujemy wszystkie pozostae komunikaty }
  { Z kadego komunikatu trzeba zwraca warto wiksz od 0. W przeciwnym razie,
    zostanie ustawiony bd i komunikat zostanie uznany za nie obsuony }


  if Assigned(Ctrl) and (ret < 0) then
  begin
    Ctrl.setError(IMERROR_NORESULT);
    ret := 0;
  end;

  Result := ret;
end;

exports
  IMessageProc;

begin
end.
